var FTglobals = {
    consoleService: Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService),
    accountManager: Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager),
	msgFolder: '',
	userId: '',
	msgSubject: '',
	numNewMsgs: 0,
	mailSession: '',
	msgStoreDb: '',
	initDbLstnr: false,
	doDebugging: false,
    folderListener: { 
        // this listener listens for New messages arriving
        //  if we see that change, we increment the number of new messages (or just new messages) indicator in the titlebar
        OnItemAdded: function(parentItem, item, view) {},
        OnItemRemoved: function(parentItem, item, view) {},
        OnItemPropertyChanged: function(item, property, oldValue, newValue) {
                if (FTglobals.doDebugging) FTglobals.consoleService.logStringMessage('FixTitle:P item>' + item + '<  property>' + 
                     property.toString() + '<  oldValue>' + oldValue + '<  NewValue>' + newValue );
                if (property.toString() == 'NumNewBiffMessages') {
                    FTglobals.numNewMsgs = newValue;
                    setTitleFromFolder(FTglobals.msgFolder, FTglobals.msgSubject)
                }
            },
        OnItemIntPropertyChanged: function(item, property, oldValue, newValue) {},
        OnItemBoolPropertyChanged: function(item, property, oldValue, newValue) {},
        OnItemUnicharPropertyChanged: function(item, property, oldValue, newValue){},
        OnItemPropertyFlagChanged: function(item, property, oldFlag, newFlag) {},
        OnItemEvent: function(folder, event) {  
            if (event.toString() == 'FolderLoaded') {  
                try {
                    setTimeout(FTglobals.initChangeListener,1); 
                } catch(e) {}
            }              
        }
    },

    dbChangeListener: {
        // this listener listens for changes to the message .
        // we are looking for changes from 'New' to anything other than new (like 'read')
        //  if we see that change, we decrement the number of new messages (or just new messages) indicator in the titlebar
        onHdrChange: function(keyChanged, oldFlags, newFlags, instigator) {
            if (FTglobals.doDebugging) FTglobals.consoleService.logStringMessage('FixTitle:dbkc keyC>' + keyChanged + '<  oldFlags>' + oldFlags + 
                 '<  newFlags>' + newFlags + '<  instigator>' + instigator );
            // an oldflag of 65536 indicates the message was previously 'new', and has changed
            if (oldFlags > 65535 && oldFlags != newFlags && FTglobals.numNewMsgs > 0) {
                FTglobals.numNewMsgs = FTglobals.numNewMsgs - 1;
                if (FTglobals.numNewMsgs < 1 ) { 
                    setTimeout(FTglobals.clearNew,500);
                }
                setTimeout(setTitleFromFolder,1,FTglobals.msgFolder, FTglobals.msgSubject);
            }
        },
        onHdrDeleted: function(keyChanged, ParentKey, Flags, instigator) {
            //if (FTglobals.doDebugging) FTglobals.consoleService.logStringMessage('FixTitle:dbkd');
            if (Flags > 65535) {
                FTglobals.numNewMsgs = FTglobals.numNewMsgs - 1;
                if (FTglobals.numNewMsgs < 1 ) { 
                    setTimeout(FTglobals.clearNew,500);
                }
                setTimeout(setTitleFromFolder,1,FTglobals.msgFolder, FTglobals.msgSubject);
            }
        },
        onHdrAdded: function(keyChanged, ParentKey, Flags, instigator) {
        },
        onKeyChange: function(keyChanged, oldFlags, newFlags, instigator) {
            if (FTglobals.doDebugging) FTglobals.consoleService.logStringMessage('FixTitle:dbkc keyC>' + keyChanged + '<  oldFlags>' + oldFlags + 
                 '<  newFlags>' + newFlags + '<  instigator>' + instigator );
            // an oldflag of 65536 indicates the message was previously 'new', and has changed
            if (oldFlags > 65535 && oldFlags != newFlags && FTglobals.numNewMsgs > 0) {
                FTglobals.numNewMsgs = FTglobals.numNewMsgs - 1;
                if (FTglobals.numNewMsgs < 1 ) { 
                    setTimeout(FTglobals.clearNew,500);
                }
                setTimeout(setTitleFromFolder,1,FTglobals.msgFolder, FTglobals.msgSubject);
            }
        },
        onKeyDeleted: function(keyChanged, ParentKey, Flags, instigator) {
            //if (FTglobals.doDebugging) FTglobals.consoleService.logStringMessage('FixTitle:dbkd');
            if (Flags > 65535) {
                FTglobals.numNewMsgs = FTglobals.numNewMsgs - 1;
                if (FTglobals.numNewMsgs < 1 ) { 
                    setTimeout(FTglobals.clearNew,500);
                }
                setTimeout(setTitleFromFolder,1,FTglobals.msgFolder, FTglobals.msgSubject);
            }
        },
        onKeyAdded: function(keyChanged, ParentKey, Flags, instigator) {
        },
        onParentChanged: function(keyChanged, oldParent, newParent, instigator) {
        },
        onAnnouncerGoingAway: function(instigator) {
        },
        onReadChanged: function(instigator) {
        },
        onJunkScoreChanged: function(instigator) {
            //if (FTglobals.doDebugging) FTglobals.consoleService.logStringMessage('FixTitle:dbjsc');
        }
    },

    clearNew: function() {
        var allServers = FTglobals.accountManager.allServers;
        for (var i=0;i<allServers.Count();i++) {
            try{
                var currentServer = allServers.GetElementAt(i).QueryInterface(Components.interfaces.nsIMsgIncomingServer);
                var msf = GetInboxFolder(currentServer);
                if (FTglobals.doDebugging) FTglobals.consoleService.logStringMessage('FTclearNew server=' + currentServer); 
     			var nsIMsgFolder = Components.interfaces.nsIMsgFolder;
                msf.biffState = nsIMsgFolder.nsMsgBiffState_NoMail;
                msf.clearNewMessages();
            } catch(e) {}
        }
    },

    initChangeListener: function() {
        try {
            try{
                FTglobals.msgStoreDb.RemoveListener(FTglobals.dbChangeListener); 
            } catch(e) {}
            FTglobals.msgStoreDb = GetDBView().db;
            if (FTglobals.msgStoreDb) {
                FTglobals.msgStoreDb = FTglobals.msgStoreDb.QueryInterface(Components.interfaces.nsIMsgDatabase);
                if (FTglobals.msgStoreDb) { 
                    FTglobals.msgStoreDb.RemoveListener(FTglobals.dbChangeListener); 
                }
                FTglobals.msgStoreDb.AddListener(FTglobals.dbChangeListener);
            }
            if (FTglobals.doDebugging) FTglobals.consoleService.logStringMessage('FixTitle: setTitle, set db listener ');
        } catch (ex) {
            if (FTglobals.doDebugging) FTglobals.consoleService.logStringMessage('FixTitle: setTitle, could not set db listener ex='+ex);
        }
    },

    initDBListener: function() {
        var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
        try {
            FTglobals.doDebugging = pref.getBoolPref("fixtitle.debug");
        } catch(e) {
            FTglobals.doDebugging = false;
            pref.setBoolPref("fixtitle.debug",FTglobals.doDebugging);
        }
        try {
            FTglobals.mailSession = Components.classes["@mozilla.org/messenger/services/session;1"].getService(Components.interfaces.nsIMsgMailSession);
            var notifyFlags = Components.interfaces.nsIFolderListener.all;
            FTglobals.mailSession.AddFolderListener(FTglobals.folderListener, notifyFlags);
            if (FTglobals.doDebugging) FTglobals.consoleService.logStringMessage('FixTitle: setTitle, set folder listener ');
            FTglobals.initDbLstnr = true;
        } catch (ex) {
            if (FTglobals.doDebugging) FTglobals.consoleService.logStringMessage('FixTitle: setTitle, could not set folder listener ex='+ex);
        }
    },

    setInitialTitle: function(title) {
        var messengerBundle = document.getElementById("bundle_messenger");
        if (title) title += " - ";
        title += FTglobals.msgFolder.prettyName;
        
        if (!FTglobals.msgFolder.isServer) {
            var server = FTglobals.msgFolder.server;
            var middle;
            var end;
            if (server.type == "nntp") {
                // <folder> on <hostname>
                middle = messengerBundle.getString("titleNewsPreHost");
                end = server.hostName;
            } else {
                var identity;
                try {
                    var identities = FTglobals.accountManager.GetIdentitiesForServer(server);
                    identity = identities.QueryElementAt(0, Components.interfaces.nsIMsgIdentity);
                    // <folder> for <email>
                    middle = messengerBundle.getString("titleMailPreHost");
                    end = identity.email;
                } catch (ex) {}
            }
            if (middle) title += " " + middle;
            if (end) title += " " + end;
        }
        return title;
    }
}

function setTitleFromFolder(msgfolder, subject)  { //////////////////////////////// This overloads the real setTitleFromFolder function
    FTglobals.msgFolder = msgfolder;
    FTglobals.msgSubject = subject;
    var messengerBundle = document.getElementById("bundle_messenger");
    var brandBundle = document.getElementById("bundle_brand");
    var title = subject || "";
    
    // set up the listener
    if (!FTglobals.initDbLstnr) FTglobals.initDBListener();
    if (msgfolder) title = FTglobals.setInitialTitle(title);
    if (window.document.documentURI.indexOf("messageWindow") > -1 ) {
        title = title + " - " + brandBundle.getString("brandShortName");
        window.title = title;
        return;
    }    

    var acctnam = accountManager.FindAccountForServer(FTglobals.msgFolder.server);
    var identemail;
    var ident;
    var servpn = ' ' + messengerBundle.getString("titleNewsPreHost") + ' ' + FTglobals.msgFolder.server.prettyName;
    try{ 
        ident = accountManager.getFirstIdentityForServer(FTglobals.msgFolder.server);
        if (!ident) ident = accountManager.accounts.QueryElementAt(0, Components.interfaces.nsIMsgAccount).defaultIdentity;  
    } catch(e) { 
        var account = accountManager.accounts.QueryElementAt(0, Components.interfaces.nsIMsgAccount);
        ident = account.defaultIdentity;
    }
    if (!ident) {
        var allIdents = accountManager.allIdentities;
        var identArray = [''];
        for (i= 0; i < allIdents.Count() ; i++ ) {
            var ident = allIdents.GetElementAt(i);
            ident instanceof Components.interfaces.nsIMsgIdentity;
            break;
        }
    }
    FTglobals.userId = ident;    
    identemail = ' ' + messengerBundle.getString("titleMailPreHost") + ' ' + ident.email;

    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    var FTstandard;
    try {
        var FTTitle = pref.getCharPref("fixtitle.title")
        var FTsep = pref.getCharPref("fixtitle.separator");
        var FTnew = pref.getCharPref("fixtitle.newstring");
        var FTshowT = pref.getBoolPref("fixtitle.showtitle");
        var FTshowS = pref.getBoolPref("fixtitle.showsubject");
        var FTshowF = pref.getBoolPref("fixtitle.showfolder");
        var FTfoldtext = pref.getIntPref("fixtitle.foldtext");
        FTstandard = pref.getBoolPref("fixtitle.standard");
        var FTOrder = pref.getIntPref("fixtitle.order");
    } catch (e) {
        title += " - " + brandBundle.getString("brandShortName");
        window.title = title;
        return;
    }
    
    var titlestr;      var FTTitle;       var FTsubj = '';        var FTfold = '';
    var foldn = msgfolder.prettyName;
    if (foldn == FTglobals.msgFolder.server.prettyName) { servpn =''}
    switch (parseInt( FTfoldtext)) {
        case 0:
            break;
        case 1:
            if (foldn) foldn = foldn + servpn;
            break;
        case 2:
            if (servpn) {
                if (foldn) foldn = foldn + identemail;
            }
            break;
        case 3:
            if (servpn  && foldn) {
                foldn = foldn + identemail + ' (' + servpn + ' )';
            }
            break;
        case 4:
            if (servpn && foldn) {
                foldn = foldn + servpn + ' (' + identemail + ' )';
            }
            break;
    }
    switch ( parseInt( FTOrder) ) {
        case 0:
            if (FTTitle == '') FTTitle = brandBundle.getString("brandShortName");
            if (!FTshowT) FTTitle = '';
            if (FTshowS && subject) FTsubj = FTsep + subject;
            if (FTshowF && foldn)  FTfold = FTsep + foldn;
            title = FTTitle + FTsubj +FTfold;
            break;
        case 1:
            if (FTTitle == '') FTTitle = brandBundle.getString("brandShortName");
            if (!FTshowT) FTTitle = '';
            if (FTshowS && subject) FTsubj = FTsep + subject;
            if (FTshowF && foldn)  FTfold = FTsep + foldn;
            title = FTTitle + FTfold +FTsubj;
            break;
        case 2:
            if (!FTshowT) {FTTitle = ''; } else { FTTitle = FTsep + FTTitle; } 
            if (FTshowS && subject) FTsubj = subject;
            if (FTshowF && foldn)  FTfold = FTsep + foldn;
            title = FTsubj + FTTitle +FTfold;
            break;
        case 3:
            if (!FTshowT) {FTTitle = ''; } else { FTTitle = FTsep + FTTitle; } 
            if (FTshowS && subject) FTsubj = subject;
            if (FTshowF && foldn)  FTfold = FTsep + foldn;
            title = FTsubj + FTfold +FTTitle;
            break;
        case 4:
            if (!FTshowT) {FTTitle = ''; } else { FTTitle = FTsep + FTTitle; } 
            if (FTshowS && subject) FTsubj = FTsep + subject;
            if (FTshowF && foldn)  FTfold = foldn;
            title = FTfold + FTsubj +FTTitle;
            break;
        case 5:
            if (!FTshowT) {FTTitle = ''; } else { FTTitle = FTsep + FTTitle; } 
            if (FTshowS && subject) FTsubj = FTsep + subject;
            if (FTshowF && foldn)  FTfold = foldn;
            title = FTfold + FTTitle +FTsubj;
        break;
    }
    title = title.substr(title.indexOf('*',2)+1);
    if(FTglobals.numNewMsgs > 0) {
        var newstr = FTnew;
        var re = /NN/gi
        newstr = newstr.replace(re,FTglobals.numNewMsgs)
        title = newstr + title;
    }
    window.title = title;
}
